View Issue Details

IDProjectCategoryView StatusLast Update
0004401SymmetricDSBugpublic2020-06-04 13:55
ReporterelongAssigned Toelong 
Prioritynormal 
Status closedResolutionfixed 
Product Version3.12.0 
Target Version3.12.0Fixed in Version3.12.0 
Summary0004401: Oracle ntype characters lost from conversion in capture
DescriptionWhen Oracle ntypes parameter is enabled and using different character sets in CHAR and NCHAR fields, the capture of changes causes casting to CHAR and loses characters for ntype fields. It seems like the use of decode() in the trigger template is causing a cast to CHAR, and we should try using nvl2() instead to preserve the original data type.

Steps To ReproduceOracle database with these NLS settings:
NLS_CHARACTERSET WE8ISO8859P1
NLS_NCHAR_CHARACTERSET AL16UTF16

CHAR fields can contain characters contained within the Latin-1 charset and NCHAR fields can contain characters within the UTF-8 charset.

For NCHAR field with value: عاقل البخاري‎
It gets captured in SYM_DATA as ¿¿¿¿ ¿¿¿¿¿¿¿¿ even though row_data is defined as an NLCOB field.
Tagscharacter encoding, dialect: oracle

Relationships

related to 0004374 closedelong NClob support fails on Oracle 

Activities

There are no notes attached to this issue.

Related Changesets

SymmetricDS: 3.12 f8fac708

2020-05-20 09:17:38

admin

Details Diff
0004401: Oracle ntype characters lost from conversion in capture
0004401
mod - symmetric-client/src/main/java/org/jumpmind/symmetric/db/oracle/OracleTriggerTemplate.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/db/AbstractTriggerTemplate.java Diff File

Issue History

Date Modified Username Field Change
2020-05-15 10:11 elong New Issue
2020-05-15 10:11 elong Status new => assigned
2020-05-15 10:11 elong Assigned To => elong
2020-05-15 10:11 elong Tag Attached: character encoding
2020-05-15 10:11 elong Tag Attached: dialect: oracle
2020-05-15 10:12 elong Relationship added related to 0004374
2020-05-20 09:18 elong Status assigned => resolved
2020-05-20 09:18 elong Resolution open => fixed
2020-05-20 09:18 elong Fixed in Version => 3.12.0
2020-05-26 14:48 elong Status resolved => closed
2020-06-04 13:55 admin Changeset attached => SymmetricDS 3.12 f8fac708